diff -Naur openssl-1.0.0q.orig/crypto/dsa/dsatest.c openssl-1.0.0q/crypto/dsa/dsatest.c
--- openssl-1.0.0q.orig/crypto/dsa/dsatest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dsa/dsatest.c	2017-04-25 16:23:40.213527694 +0200
@@ -62,11 +62,13 @@
 #undef OPENSSL_NO_DEPRECATED
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <sys/types.h>
 #include <sys/stat.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -183,7 +185,7 @@
 
 	i=BN_bn2bin(dsa->q,buf);
 	j=sizeof(out_q);
-	if ((i != j) || (memcmp(buf,out_q,i) != 0))
+	if ((i != j) || (op_memcmp(buf,out_q,i) != 0))
 		{
 		BIO_printf(bio_err,"q value is wrong\n");
 		goto end;
@@ -191,7 +193,7 @@
 
 	i=BN_bn2bin(dsa->p,buf);
 	j=sizeof(out_p);
-	if ((i != j) || (memcmp(buf,out_p,i) != 0))
+	if ((i != j) || (op_memcmp(buf,out_p,i) != 0))
 		{
 		BIO_printf(bio_err,"p value is wrong\n");
 		goto end;
@@ -199,7 +201,7 @@
 
 	i=BN_bn2bin(dsa->g,buf);
 	j=sizeof(out_g);
-	if ((i != j) || (memcmp(buf,out_g,i) != 0))
+	if ((i != j) || (op_memcmp(buf,out_g,i) != 0))
 		{
 		BIO_printf(bio_err,"g value is wrong\n");
 		goto end;
diff -Naur openssl-1.0.0q.orig/crypto/dso/.gitignore openssl-1.0.0q/crypto/dso/.gitignore
--- openssl-1.0.0q.orig/crypto/dso/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/.gitignore	2017-04-25 16:23:40.219528177 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_dl.c openssl-1.0.0q/crypto/dso/dso_dl.c
--- openssl-1.0.0q.orig/crypto/dso/dso_dl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_dl.c	2017-04-25 16:23:40.219528177 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
@@ -326,12 +328,12 @@
 	char *translated;
 	int len, rsize, transform;
 
-	len = strlen(filename);
+	len = op_strlen(filename);
 	rsize = len + 1;
-	transform = (strstr(filename, "/") == NULL);
+	transform = (op_strstr(filename, "/") == NULL);
 		{
 		/* We will convert this to "%s.s?" or "lib%s.s?" */
-		rsize += strlen(extension);/* The length of ".s?" */
+		rsize += op_strlen(extension);/* The length of ".s?" */
 		if ((DSO_flags(dso) & DSO_FLAG_NAME_TRANSLATION_EXT_ONLY) == 0)
 			rsize += 3; /* The length of "lib" */
 		}
@@ -345,12 +347,12 @@
 	if(transform)
 		{
 		if ((DSO_flags(dso) & DSO_FLAG_NAME_TRANSLATION_EXT_ONLY) == 0)
-			sprintf(translated, "lib%s%s", filename, extension);
+			op_sprintf(translated, "lib%s%s", filename, extension);
 		else
-			sprintf(translated, "%s%s", filename, extension);
+			op_sprintf(translated, "%s%s", filename, extension);
 		}
 	else
-		sprintf(translated, "%s", filename);
+		op_sprintf(translated, "%s", filename);
 	return(translated);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_dlfcn.c openssl-1.0.0q/crypto/dso/dso_dlfcn.c
--- openssl-1.0.0q.orig/crypto/dso/dso_dlfcn.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_dlfcn.c	2017-04-25 16:23:40.221527873 +0200
@@ -66,7 +66,9 @@
 # endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
@@ -372,9 +374,9 @@
 	char *translated;
 	int len, rsize, transform;
 
-	len = strlen(filename);
+	len = op_strlen(filename);
 	rsize = len + 1;
-	transform = (strstr(filename, "/") == NULL);
+	transform = (op_strstr(filename, "/") == NULL);
 	if(transform)
 		{
 		/* We will convert this to "%s.so" or "lib%s.so" etc */
@@ -397,7 +399,7 @@
 			sprintf(translated, "%s" DSO_ext, filename);
 		}
 	else
-		sprintf(translated, "%s", filename);
+		op_sprintf(translated, "%s", filename);
 	return(translated);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_err.c openssl-1.0.0q/crypto/dso/dso_err.c
--- openssl-1.0.0q.orig/crypto/dso/dso_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_err.c	2017-04-25 16:23:40.222527720 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/dso.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_lib.c openssl-1.0.0q/crypto/dso/dso_lib.c
--- openssl-1.0.0q.orig/crypto/dso/dso_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_lib.c	2017-04-25 16:23:40.223527009 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/crypto.h>
 #include "cryptlib.h"
 #include <openssl/dso.h>
@@ -377,13 +379,13 @@
 		return(0);
 		}
 	/* We'll duplicate filename */
-	copied = OPENSSL_malloc(strlen(filename) + 1);
+	copied = OPENSSL_malloc(op_strlen(filename) + 1);
 	if(copied == NULL)
 		{
 		DSOerr(DSO_F_DSO_SET_FILENAME,ERR_R_MALLOC_FAILURE);
 		return(0);
 		}
-	BUF_strlcpy(copied, filename, strlen(filename) + 1);
+	BUF_strlcpy(copied, filename, op_strlen(filename) + 1);
 	if(dso->filename)
 		OPENSSL_free(dso->filename);
 	dso->filename = copied;
@@ -435,14 +437,14 @@
 		}
 	if(result == NULL)
 		{
-		result = OPENSSL_malloc(strlen(filename) + 1);
+		result = OPENSSL_malloc(op_strlen(filename) + 1);
 		if(result == NULL)
 			{
 			DSOerr(DSO_F_DSO_CONVERT_FILENAME,
 					ERR_R_MALLOC_FAILURE);
 			return(NULL);
 			}
-		BUF_strlcpy(result, filename, strlen(filename) + 1);
+		BUF_strlcpy(result, filename, op_strlen(filename) + 1);
 		}
 	return(result);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_null.c openssl-1.0.0q/crypto/dso/dso_null.c
--- openssl-1.0.0q.orig/crypto/dso/dso_null.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_null.c	2017-04-25 16:23:40.223527009 +0200
@@ -59,7 +59,9 @@
 /* This "NULL" method is provided as the fallback for systems that have
  * no appropriate support for "shared-libraries". */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_openssl.c openssl-1.0.0q/crypto/dso/dso_openssl.c
--- openssl-1.0.0q.orig/crypto/dso/dso_openssl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_openssl.c	2017-04-25 16:23:40.224528254 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_vms.c openssl-1.0.0q/crypto/dso/dso_vms.c
--- openssl-1.0.0q.orig/crypto/dso/dso_vms.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_vms.c	2017-04-25 16:23:40.225527822 +0200
@@ -56,9 +56,14 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
@@ -192,27 +197,27 @@
 	 */
 	/* Start with trying to find the end of a dir-spec, and save the
 	   position of the byte after in sp1 */
-	sp1 = strrchr(filename, ']');
-	sp2 = strrchr(filename, '>');
+	sp1 = op_strrchr(filename, ']');
+	sp2 = op_strrchr(filename, '>');
 	if (sp1 == NULL) sp1 = sp2;
 	if (sp2 != NULL && sp2 > sp1) sp1 = sp2;
-	if (sp1 == NULL) sp1 = strrchr(filename, ':');
+	if (sp1 == NULL) sp1 = op_strrchr(filename, ':');
 	if (sp1 == NULL)
 		sp1 = filename;
 	else
 		sp1++;		/* The byte after the found character */
 	/* Now, let's see if there's a type, and save the position in sp2 */
-	sp2 = strchr(sp1, '.');
+	sp2 = op_strchr(sp1, '.');
 	/* If we found it, that's where we'll cut.  Otherwise, look for a
 	   version number and save the position in sp2 */
-	if (sp2 == NULL) sp2 = strchr(sp1, ';');
+	if (sp2 == NULL) sp2 = op_strchr(sp1, ';');
 	/* If there was still nothing to find, set sp2 to point at the end of
 	   the string */
-	if (sp2 == NULL) sp2 = sp1 + strlen(sp1);
+	if (sp2 == NULL) sp2 = sp1 + op_strlen(sp1);
 
 	/* Check that we won't get buffer overflows */
 	if (sp2 - sp1 > FILENAME_MAX
-		|| (sp1 - filename) + strlen(sp2) > FILENAME_MAX)
+		|| (sp1 - filename) + op_strlen(sp2) > FILENAME_MAX)
 		{
 		DSOerr(DSO_F_VMS_LOAD,DSO_R_FILENAME_TOO_BIG);
 		goto err;
@@ -225,18 +230,18 @@
 		goto err;
 		}
 
-	strncpy(p->filename, sp1, sp2-sp1);
+	op_strncpy(p->filename, sp1, sp2-sp1);
 	p->filename[sp2-sp1] = '\0';
 
-	strncpy(p->imagename, filename, sp1-filename);
+	op_strncpy(p->imagename, filename, sp1-filename);
 	p->imagename[sp1-filename] = '\0';
-	strcat(p->imagename, sp2);
+	op_strcat(p->imagename, sp2);
 
-	p->filename_dsc.dsc$w_length = strlen(p->filename);
+	p->filename_dsc.dsc$w_length = op_strlen(p->filename);
 	p->filename_dsc.dsc$b_dtype = DSC$K_DTYPE_T;
 	p->filename_dsc.dsc$b_class = DSC$K_CLASS_S;
 	p->filename_dsc.dsc$a_pointer = p->filename;
-	p->imagename_dsc.dsc$w_length = strlen(p->imagename);
+	p->imagename_dsc.dsc$w_length = op_strlen(p->imagename);
 	p->imagename_dsc.dsc$b_dtype = DSC$K_DTYPE_T;
 	p->imagename_dsc.dsc$b_class = DSC$K_CLASS_S;
 	p->imagename_dsc.dsc$a_pointer = p->imagename;
@@ -516,9 +521,9 @@
 
 static char *vms_name_converter(DSO *dso, const char *filename)
 	{
-        int len = strlen(filename);
+        int len = op_strlen(filename);
         char *not_translated = OPENSSL_malloc(len+1);
-        strcpy(not_translated,filename);
+        op_strcpy(not_translated,filename);
 	return(not_translated);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/dso/dso_win32.c openssl-1.0.0q/crypto/dso/dso_win32.c
--- openssl-1.0.0q.orig/crypto/dso/dso_win32.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/dso/dso_win32.c	2017-04-25 16:23:40.226527670 +0200
@@ -56,8 +56,10 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/dso.h>
 
@@ -632,10 +634,10 @@
 	char *translated;
 	int len, transform;
 
-	len = strlen(filename);
-	transform = ((strstr(filename, "/") == NULL) &&
-			(strstr(filename, "\\") == NULL) &&
-			(strstr(filename, ":") == NULL));
+	len = op_strlen(filename);
+	transform = ((op_strstr(filename, "/") == NULL) &&
+			(op_strstr(filename, "\\") == NULL) &&
+			(op_strstr(filename, ":") == NULL));
 	if(transform)
 		/* We will convert this to "%s.dll" */
 		translated = OPENSSL_malloc(len + 5);
@@ -649,9 +651,9 @@
 		return(NULL);   
 		}
 	if(transform)
-		sprintf(translated, "%s.dll", filename);
+		op_sprintf(translated, "%s.dll", filename);
 	else
-		sprintf(translated, "%s", filename);
+		op_sprintf(translated, "%s", filename);
 	return(translated);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/ebcdic.c openssl-1.0.0q/crypto/ebcdic.c
--- openssl-1.0.0q.orig/crypto/ebcdic.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ebcdic.c	2017-04-25 16:23:40.227526680 +0200
@@ -189,7 +189,7 @@
 /* Translate a memory block from EBCDIC (host charset) to ASCII (net charset)
  * dest and srce may be identical, or separate memory blocks, but
  * should not overlap. These functions intentionally have an interface
- * compatible to memcpy(3).
+ * compatible to op_memcpy(3).
  */
 
 void *
diff -Naur openssl-1.0.0q.orig/crypto/ebcdic.h openssl-1.0.0q/crypto/ebcdic.h
--- openssl-1.0.0q.orig/crypto/ebcdic.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ebcdic.h	2017-04-25 16:23:40.228526807 +0200
@@ -3,7 +3,9 @@
 #ifndef HEADER_EBCDIC_H
 #define HEADER_EBCDIC_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 /* Avoid name clashes with other applications */
 #define os_toascii   _openssl_os_toascii
diff -Naur openssl-1.0.0q.orig/crypto/ec/.gitignore openssl-1.0.0q/crypto/ec/.gitignore
--- openssl-1.0.0q.orig/crypto/ec/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/.gitignore	2017-04-25 16:23:40.229526934 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ec/ec_asn1.c openssl-1.0.0q/crypto/ec/ec_asn1.c
--- openssl-1.0.0q.orig/crypto/ec/ec_asn1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/ec_asn1.c	2017-04-25 16:23:40.230528458 +0200
@@ -196,78 +196,82 @@
 	} EC_PRIVATEKEY;
 
 /* the OpenSSL ASN.1 definitions */
-ASN1_SEQUENCE(X9_62_PENTANOMIAL) = {
-	ASN1_SIMPLE(X9_62_PENTANOMIAL, k1, LONG),
-	ASN1_SIMPLE(X9_62_PENTANOMIAL, k2, LONG),
+ASN1_SEQUENCE(X9_62_PENTANOMIAL) 
+	ASN1_SIMPLE(X9_62_PENTANOMIAL, k1, LONG)
+	ASN1_SIMPLE(X9_62_PENTANOMIAL, k2, LONG)
 	ASN1_SIMPLE(X9_62_PENTANOMIAL, k3, LONG)
-} ASN1_SEQUENCE_END(X9_62_PENTANOMIAL)
+ASN1_SEQUENCE_END(X9_62_PENTANOMIAL)
 
 DECLARE_ASN1_ALLOC_FUNCTIONS(X9_62_PENTANOMIAL)
 IMPLEMENT_ASN1_ALLOC_FUNCTIONS(X9_62_PENTANOMIAL)
 
-ASN1_ADB_TEMPLATE(char_two_def) = ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, p.other, ASN1_ANY);
-
-ASN1_ADB(X9_62_CHARACTERISTIC_TWO) = {
-	ADB_ENTRY(NID_X9_62_onBasis, ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, p.onBasis, ASN1_NULL)),
-	ADB_ENTRY(NID_X9_62_tpBasis, ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, p.tpBasis, ASN1_INTEGER)),
-	ADB_ENTRY(NID_X9_62_ppBasis, ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, p.ppBasis, X9_62_PENTANOMIAL))
-} ASN1_ADB_END(X9_62_CHARACTERISTIC_TWO, 0, type, 0, &char_two_def_tt, NULL);
-
-ASN1_SEQUENCE(X9_62_CHARACTERISTIC_TWO) = {
-	ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, m, LONG),
-	ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, type, ASN1_OBJECT),
+ASN1_ADB_TEMPLATE(char_two_def) 
+	ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, p.other, ASN1_ANY)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_SEQ(X9_62_CHARACTERISTIC_TWO)
+	ADB_ENTRY(NID_X9_62_onBasis, ASN1_SIMPLE2(X9_62_CHARACTERISTIC_TWO, p.onBasis, ASN1_NULL))
+	ADB_ENTRY(NID_X9_62_tpBasis, ASN1_SIMPLE2(X9_62_CHARACTERISTIC_TWO, p.tpBasis, ASN1_INTEGER))
+	ADB_ENTRY(NID_X9_62_ppBasis, ASN1_SIMPLE2(X9_62_CHARACTERISTIC_TWO, p.ppBasis, X9_62_PENTANOMIAL))
+ASN1_ADB_END(X9_62_CHARACTERISTIC_TWO, 0, type, 0, char_two_def_tt, NULL)
+
+ASN1_SEQUENCE(X9_62_CHARACTERISTIC_TWO) 
+	ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, m, LONG)
+	ASN1_SIMPLE(X9_62_CHARACTERISTIC_TWO, type, ASN1_OBJECT)
 	ASN1_ADB_OBJECT(X9_62_CHARACTERISTIC_TWO)
-} ASN1_SEQUENCE_END(X9_62_CHARACTERISTIC_TWO)
+ASN1_SEQUENCE_END(X9_62_CHARACTERISTIC_TWO)
 
 DECLARE_ASN1_ALLOC_FUNCTIONS(X9_62_CHARACTERISTIC_TWO)
 IMPLEMENT_ASN1_ALLOC_FUNCTIONS(X9_62_CHARACTERISTIC_TWO)
 
-ASN1_ADB_TEMPLATE(fieldID_def) = ASN1_SIMPLE(X9_62_FIELDID, p.other, ASN1_ANY);
-
-ASN1_ADB(X9_62_FIELDID) = {
-	ADB_ENTRY(NID_X9_62_prime_field, ASN1_SIMPLE(X9_62_FIELDID, p.prime, ASN1_INTEGER)),
-	ADB_ENTRY(NID_X9_62_characteristic_two_field, ASN1_SIMPLE(X9_62_FIELDID, p.char_two, X9_62_CHARACTERISTIC_TWO))
-} ASN1_ADB_END(X9_62_FIELDID, 0, fieldType, 0, &fieldID_def_tt, NULL);
+ASN1_ADB_TEMPLATE(fieldID_def) 
+	ASN1_SIMPLE(X9_62_FIELDID, p.other, ASN1_ANY)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_(X9_62_FIELDID) = {
+	ADB_ENTRY(NID_X9_62_prime_field, ASN1_SIMPLE2(X9_62_FIELDID, p.prime, ASN1_INTEGER))
+	ADB_ENTRY(NID_X9_62_characteristic_two_field, ASN1_SIMPLE2(X9_62_FIELDID, p.char_two, X9_62_CHARACTERISTIC_TWO))
+ASN1_ADB_END(X9_62_FIELDID, 0, fieldType, 0, fieldID_def_tt, NULL)
 
-ASN1_SEQUENCE(X9_62_FIELDID) = {
-	ASN1_SIMPLE(X9_62_FIELDID, fieldType, ASN1_OBJECT),
+ASN1_SEQUENCE(X9_62_FIELDID) 
+	ASN1_SIMPLE(X9_62_FIELDID, fieldType, ASN1_OBJECT)
 	ASN1_ADB_OBJECT(X9_62_FIELDID)
-} ASN1_SEQUENCE_END(X9_62_FIELDID)
+ASN1_SEQUENCE_END(X9_62_FIELDID)
 
-ASN1_SEQUENCE(X9_62_CURVE) = {
-	ASN1_SIMPLE(X9_62_CURVE, a, ASN1_OCTET_STRING),
-	ASN1_SIMPLE(X9_62_CURVE, b, ASN1_OCTET_STRING),
+ASN1_SEQUENCE(X9_62_CURVE) 
+	ASN1_SIMPLE(X9_62_CURVE, a, ASN1_OCTET_STRING)
+	ASN1_SIMPLE(X9_62_CURVE, b, ASN1_OCTET_STRING)
 	ASN1_OPT(X9_62_CURVE, seed, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END(X9_62_CURVE)
+ASN1_SEQUENCE_END(X9_62_CURVE)
 
-ASN1_SEQUENCE(ECPARAMETERS) = {
-	ASN1_SIMPLE(ECPARAMETERS, version, LONG),
-	ASN1_SIMPLE(ECPARAMETERS, fieldID, X9_62_FIELDID),
-	ASN1_SIMPLE(ECPARAMETERS, curve, X9_62_CURVE),
-	ASN1_SIMPLE(ECPARAMETERS, base, ASN1_OCTET_STRING),
-	ASN1_SIMPLE(ECPARAMETERS, order, ASN1_INTEGER),
+ASN1_SEQUENCE(ECPARAMETERS) 
+	ASN1_SIMPLE(ECPARAMETERS, version, LONG)
+	ASN1_SIMPLE(ECPARAMETERS, fieldID, X9_62_FIELDID)
+	ASN1_SIMPLE(ECPARAMETERS, curve, X9_62_CURVE)
+	ASN1_SIMPLE(ECPARAMETERS, base, ASN1_OCTET_STRING)
+	ASN1_SIMPLE(ECPARAMETERS, order, ASN1_INTEGER)
 	ASN1_OPT(ECPARAMETERS, cofactor, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(ECPARAMETERS)
+ASN1_SEQUENCE_END(ECPARAMETERS)
 
 DECLARE_ASN1_ALLOC_FUNCTIONS(ECPARAMETERS)
 IMPLEMENT_ASN1_ALLOC_FUNCTIONS(ECPARAMETERS)
 
-ASN1_CHOICE(ECPKPARAMETERS) = {
-	ASN1_SIMPLE(ECPKPARAMETERS, value.named_curve, ASN1_OBJECT),
-	ASN1_SIMPLE(ECPKPARAMETERS, value.parameters, ECPARAMETERS),
+ASN1_CHOICE(ECPKPARAMETERS)
+	ASN1_SIMPLE(ECPKPARAMETERS, value.named_curve, ASN1_OBJECT)
+	ASN1_SIMPLE(ECPKPARAMETERS, value.parameters, ECPARAMETERS)
 	ASN1_SIMPLE(ECPKPARAMETERS, value.implicitlyCA, ASN1_NULL)
-} ASN1_CHOICE_END(ECPKPARAMETERS)
+ASN1_CHOICE_END(ECPKPARAMETERS)
 
 DECLARE_ASN1_FUNCTIONS_const(ECPKPARAMETERS)
 DECLARE_ASN1_ENCODE_FUNCTIONS_const(ECPKPARAMETERS, ECPKPARAMETERS)
 IMPLEMENT_ASN1_FUNCTIONS_const(ECPKPARAMETERS)
 
-ASN1_SEQUENCE(EC_PRIVATEKEY) = {
-	ASN1_SIMPLE(EC_PRIVATEKEY, version, LONG),
-	ASN1_SIMPLE(EC_PRIVATEKEY, privateKey, ASN1_OCTET_STRING),
-	ASN1_EXP_OPT(EC_PRIVATEKEY, parameters, ECPKPARAMETERS, 0),
+ASN1_SEQUENCE(EC_PRIVATEKEY) 
+	ASN1_SIMPLE(EC_PRIVATEKEY, version, LONG)
+	ASN1_SIMPLE(EC_PRIVATEKEY, privateKey, ASN1_OCTET_STRING)
+	ASN1_EXP_OPT(EC_PRIVATEKEY, parameters, ECPKPARAMETERS, 0)
 	ASN1_EXP_OPT(EC_PRIVATEKEY, publicKey, ASN1_BIT_STRING, 1)
-} ASN1_SEQUENCE_END(EC_PRIVATEKEY)
+ASN1_SEQUENCE_END(EC_PRIVATEKEY)
 
 DECLARE_ASN1_FUNCTIONS_const(EC_PRIVATEKEY)
 DECLARE_ASN1_ENCODE_FUNCTIONS_const(EC_PRIVATEKEY, EC_PRIVATEKEY)
diff -Naur openssl-1.0.0q.orig/crypto/ec/ec_err.c openssl-1.0.0q/crypto/ec/ec_err.c
--- openssl-1.0.0q.orig/crypto/ec/ec_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/ec_err.c	2017-04-25 16:23:40.232527595 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/ec.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/ec/ec_lcl.h openssl-1.0.0q/crypto/ec/ec_lcl.h
--- openssl-1.0.0q.orig/crypto/ec/ec_lcl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/ec_lcl.h	2017-04-25 16:23:40.233528560 +0200
@@ -70,7 +70,9 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/obj_mac.h>
 #include <openssl/ec.h>
diff -Naur openssl-1.0.0q.orig/crypto/ec/ec_lib.c openssl-1.0.0q/crypto/ec/ec_lib.c
--- openssl-1.0.0q.orig/crypto/ec/ec_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/ec_lib.c	2017-04-25 16:23:40.234527569 +0200
@@ -61,7 +61,9 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/err.h>
 #include <openssl/opensslv.h>
diff -Naur openssl-1.0.0q.orig/crypto/ec/ectest.c openssl-1.0.0q/crypto/ec/ectest.c
--- openssl-1.0.0q.orig/crypto/ec/ectest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ec/ectest.c	2017-04-25 16:23:40.235527138 +0200
@@ -69,15 +69,19 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifdef FLAT_INC
 #include "e_os.h"
 #else
 #include "../e_os.h"
 #endif
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 
 #ifdef OPENSSL_NO_EC
@@ -147,7 +151,7 @@
 			}
 		}
 
-	clck = clock();
+	clck = op_clock();
 	for (i = 0; i < 10; i++)
 		{
 		for (j = 0; j < 10; j++)
@@ -156,7 +160,7 @@
 				(type != TIMING_BASE_PT) ? P : NULL, (type != TIMING_BASE_PT) ? r0[i] : NULL, ctx)) ABORT;
 			}
 		}
-	clck = clock() - clck;
+	clck = op_clock() - clck;
 
 	fprintf(stdout, "\n");
 
diff -Naur openssl-1.0.0q.orig/crypto/ecdh/.gitignore openssl-1.0.0q/crypto/ecdh/.gitignore
--- openssl-1.0.0q.orig/crypto/ecdh/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ecdh/.gitignore	2017-04-25 16:23:40.236527544 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ecdh/ecdhtest.c openssl-1.0.0q/crypto/ecdh/ecdhtest.c
--- openssl-1.0.0q.orig/crypto/ecdh/ecdhtest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ecdh/ecdhtest.c	2017-04-25 16:23:40.237527392 +0200
@@ -67,6 +67,9 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
diff -Naur openssl-1.0.0q.orig/crypto/ecdsa/.gitignore openssl-1.0.0q/crypto/ecdsa/.gitignore
--- openssl-1.0.0q.orig/crypto/ecdsa/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ecdsa/.gitignore	2017-04-25 16:23:40.238527519 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ecdsa/ecs_asn1.c openssl-1.0.0q/crypto/ecdsa/ecs_asn1.c
--- openssl-1.0.0q.orig/crypto/ecdsa/ecs_asn1.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ecdsa/ecs_asn1.c	2017-04-25 16:23:40.238527519 +0200
@@ -57,10 +57,10 @@
 #include <openssl/err.h>
 #include <openssl/asn1t.h>
 
-ASN1_SEQUENCE(ECDSA_SIG) = {
-	ASN1_SIMPLE(ECDSA_SIG, r, CBIGNUM),
+ASN1_SEQUENCE(ECDSA_SIG) 
+	ASN1_SIMPLE(ECDSA_SIG, r, CBIGNUM)
 	ASN1_SIMPLE(ECDSA_SIG, s, CBIGNUM)
-} ASN1_SEQUENCE_END(ECDSA_SIG)
+ASN1_SEQUENCE_END(ECDSA_SIG)
 
 DECLARE_ASN1_FUNCTIONS_const(ECDSA_SIG)
 DECLARE_ASN1_ENCODE_FUNCTIONS_const(ECDSA_SIG, ECDSA_SIG)
diff -Naur openssl-1.0.0q.orig/crypto/ecdsa/ecs_lib.c openssl-1.0.0q/crypto/ecdsa/ecs_lib.c
--- openssl-1.0.0q.orig/crypto/ecdsa/ecs_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ecdsa/ecs_lib.c	2017-04-25 16:23:40.239527926 +0200
@@ -210,7 +210,7 @@
 	int ret,i;
 	ASN1_INTEGER bs;
 	BIGNUM	*order=NULL;
-	unsigned char buf[4];
+	unsigned char buf[4]; /* ARRAY OK 2007-11-07 yngve */
 	const EC_GROUP *group;
 
 	if (r == NULL)
diff -Naur openssl-1.0.0q.orig/crypto/engine/.gitignore openssl-1.0.0q/crypto/engine/.gitignore
--- openssl-1.0.0q.orig/crypto/engine/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/.gitignore	2017-04-25 16:23:40.240527773 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_cnf.c openssl-1.0.0q/crypto/engine/eng_cnf.c
--- openssl-1.0.0q.orig/crypto/engine/eng_cnf.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_cnf.c	2017-04-25 16:23:40.241527621 +0200
@@ -56,9 +56,14 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "eng_int.h"
 #include <openssl/conf.h>
 
+#ifndef OPERA_SMALL_VERSION
 /* #define ENGINE_CONF_DEBUG */
 
 /* ENGINE config module */
@@ -66,7 +71,7 @@
 static char *skip_dot(char *name)
 	{
 	char *p;
-	p = strchr(name, '.');
+	p = op_strchr(name, '.');
 	if (p)
 		return p + 1;
 	return name;
@@ -125,12 +130,12 @@
 		/* First handle some special pseudo ctrls */
 
 		/* Override engine name to use */
-		if (!strcmp(ctrlname, "engine_id"))
+		if (!op_strcmp(ctrlname, "engine_id"))
 			name = ctrlvalue;
 		else if (!strcmp(ctrlname, "soft_load"))
 			soft = 1;
 		/* Load a dynamic ENGINE */
-		else if (!strcmp(ctrlname, "dynamic_path"))
+		else if (!op_strcmp(ctrlname, "dynamic_path"))
 			{
 			e = ENGINE_by_id("dynamic");
 			if (!e)
@@ -162,9 +167,9 @@
 			/* Allow "EMPTY" to mean no value: this allows a valid
 			 * "value" to be passed to ctrls of type NO_INPUT
 		 	 */
-			if (!strcmp(ctrlvalue, "EMPTY"))
+			if (!op_strcmp(ctrlvalue, "EMPTY"))
 				ctrlvalue = NULL;
-			if (!strcmp(ctrlname, "init"))
+			if (!op_strcmp(ctrlname, "init"))
 				{
 				if (!NCONF_get_number_e(cnf, value, "init", &do_init))
 					goto err;
@@ -179,7 +184,7 @@
 					goto err;
 					}
 				}
-			else if (!strcmp(ctrlname, "default_algorithms"))
+			else if (!op_strcmp(ctrlname, "default_algorithms"))
 				{
 				if (!ENGINE_set_default_string(e, ctrlvalue))
 					goto err;
@@ -253,7 +258,11 @@
 
 void ENGINE_add_conf_module(void)
 	{
+#ifndef OPERA_SMALL_VERSION
 	CONF_module_add("engines",
 			int_engine_module_init,
 			int_engine_module_finish);
+#endif
 	}
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_ctrl.c openssl-1.0.0q/crypto/engine/eng_ctrl.c
--- openssl-1.0.0q.orig/crypto/engine/eng_ctrl.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_ctrl.c	2017-04-25 16:23:40.242528307 +0200
@@ -53,6 +53,7 @@
  *
  */
 
+#include <openssl/cryptlib.h>
 #include "eng_int.h"
 
 /* When querying a ENGINE-specific control command's 'description', this string
@@ -73,7 +74,7 @@
 static int int_ctrl_cmd_by_name(const ENGINE_CMD_DEFN *defn, const char *s)
 	{
 	int idx = 0;
-	while(!int_ctrl_cmd_is_null(defn) && (strcmp(defn->cmd_name, s) != 0))
+	while(!int_ctrl_cmd_is_null(defn) && (op_strcmp(defn->cmd_name, s) != 0))
 		{
 		idx++;
 		defn++;
@@ -156,20 +157,20 @@
 		else
 			return e->cmd_defns[idx].cmd_num;
 	case ENGINE_CTRL_GET_NAME_LEN_FROM_CMD:
-		return strlen(e->cmd_defns[idx].cmd_name);
+		return op_strlen(e->cmd_defns[idx].cmd_name);
 	case ENGINE_CTRL_GET_NAME_FROM_CMD:
 		return BIO_snprintf(s,strlen(e->cmd_defns[idx].cmd_name) + 1,
 				    "%s", e->cmd_defns[idx].cmd_name);
 	case ENGINE_CTRL_GET_DESC_LEN_FROM_CMD:
 		if(e->cmd_defns[idx].cmd_desc)
-			return strlen(e->cmd_defns[idx].cmd_desc);
-		return strlen(int_no_description);
+			return op_strlen(e->cmd_defns[idx].cmd_desc);
+		return op_strlen(int_no_description);
 	case ENGINE_CTRL_GET_DESC_FROM_CMD:
 		if(e->cmd_defns[idx].cmd_desc)
 			return BIO_snprintf(s,
-					    strlen(e->cmd_defns[idx].cmd_desc) + 1,
+					    op_strlen(e->cmd_defns[idx].cmd_desc) + 1,
 					    "%s", e->cmd_defns[idx].cmd_desc);
-		return BIO_snprintf(s, strlen(int_no_description) + 1,"%s",
+		return BIO_snprintf(s, op_strlen(int_no_description) + 1,"%s",
 				    int_no_description);
 	case ENGINE_CTRL_GET_CMD_FLAGS:
 		return e->cmd_defns[idx].cmd_flags;
@@ -374,7 +375,7 @@
 			ENGINE_R_INTERNAL_LIST_ERROR);
 		return 0;
 		}
-	l = strtol(arg, &ptr, 10);
+	l = op_strtol(arg, &ptr, 10);
 	if((arg == ptr) || (*ptr != '\0'))
 		{
 		ENGINEerr(ENGINE_F_ENGINE_CTRL_CMD_STRING,
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_dyn.c openssl-1.0.0q/crypto/engine/eng_dyn.c
--- openssl-1.0.0q.orig/crypto/engine/eng_dyn.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_dyn.c	2017-04-25 16:23:40.243527875 +0200
@@ -57,6 +57,7 @@
  */
 
 
+#include <openssl/cryptlib.h>
 #include "eng_int.h"
 #include <openssl/dso.h>
 
@@ -192,7 +193,7 @@
 		ENGINEerr(ENGINE_F_DYNAMIC_SET_DATA_CTX,ERR_R_MALLOC_FAILURE);
 		return 0;
 		}
-	memset(c, 0, sizeof(dynamic_data_ctx));
+	op_memset(c, 0, sizeof(dynamic_data_ctx));
 	c->dynamic_dso = NULL;
 	c->v_check = NULL;
 	c->bind_engine = NULL;
@@ -334,7 +335,7 @@
 		{
 	case DYNAMIC_CMD_SO_PATH:
 		/* a NULL 'p' or a string of zero-length is the same thing */
-		if(p && (strlen((const char *)p) < 1))
+		if(p && (op_strlen((const char *)p) < 1))
 			p = NULL;
 		if(ctx->DYNAMIC_LIBNAME)
 			OPENSSL_free((void*)ctx->DYNAMIC_LIBNAME);
@@ -348,7 +349,7 @@
 		return 1;
 	case DYNAMIC_CMD_ID:
 		/* a NULL 'p' or a string of zero-length is the same thing */
-		if(p && (strlen((const char *)p) < 1))
+		if(p && (op_strlen((const char *)p) < 1))
 			p = NULL;
 		if(ctx->engine_id)
 			OPENSSL_free((void*)ctx->engine_id);
@@ -490,7 +491,7 @@
 		}
 	/* First binary copy the ENGINE structure so that we can roll back if
 	 * the hand-over fails */
-	memcpy(&cpy, e, sizeof(ENGINE));
+	op_memcpy(&cpy, e, sizeof(ENGINE));
 	/* Provide the ERR, "ex_data", memory, and locking callbacks so the
 	 * loaded library uses our state rather than its own. FIXME: As noted in
 	 * engine.h, much of this would be simplified if each area of code
@@ -520,7 +521,7 @@
 		ctx->dynamic_dso = NULL;
 		ENGINEerr(ENGINE_F_DYNAMIC_LOAD,ENGINE_R_INIT_FAILED);
 		/* Copy the original ENGINE structure back */
-		memcpy(e, &cpy, sizeof(ENGINE));
+		op_memcpy(e, &cpy, sizeof(ENGINE));
 		return 0;
 		}
 	/* Do we try to add this ENGINE to the internal list too? */
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_err.c openssl-1.0.0q/crypto/engine/eng_err.c
--- openssl-1.0.0q.orig/crypto/engine/eng_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_err.c	2017-04-25 16:23:40.244527723 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/engine.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_fat.c openssl-1.0.0q/crypto/engine/eng_fat.c
--- openssl-1.0.0q.orig/crypto/engine/eng_fat.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_fat.c	2017-04-25 16:23:40.245527571 +0200
@@ -58,9 +58,12 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
+#include <openssl/cryptlib.h>
 #include "eng_int.h"
 #include <openssl/conf.h>
 
+
+#ifndef OPERA_SMALL_VERSION
 int ENGINE_set_default(ENGINE *e, unsigned int flags)
 	{
 	if((flags & ENGINE_METHOD_CIPHERS) && !ENGINE_set_default_ciphers(e))
@@ -103,23 +106,23 @@
 static int int_def_cb(const char *alg, int len, void *arg)
 	{
 	unsigned int *pflags = arg;
-	if (!strncmp(alg, "ALL", len))
+	if (!op_strncmp(alg, "ALL", len))
 		*pflags |= ENGINE_METHOD_ALL;
-	else if (!strncmp(alg, "RSA", len))
+	else if (!op_strncmp(alg, "RSA", len))
 		*pflags |= ENGINE_METHOD_RSA;
-	else if (!strncmp(alg, "DSA", len))
+	else if (!op_strncmp(alg, "DSA", len))
 		*pflags |= ENGINE_METHOD_DSA;
-	else if (!strncmp(alg, "ECDH", len))
+	else if (!op_strncmp(alg, "ECDH", len))
 		*pflags |= ENGINE_METHOD_ECDH;
-	else if (!strncmp(alg, "ECDSA", len))
+	else if (!op_strncmp(alg, "ECDSA", len))
 		*pflags |= ENGINE_METHOD_ECDSA;
-	else if (!strncmp(alg, "DH", len))
+	else if (!op_strncmp(alg, "DH", len))
 		*pflags |= ENGINE_METHOD_DH;
-	else if (!strncmp(alg, "RAND", len))
+	else if (!op_strncmp(alg, "RAND", len))
 		*pflags |= ENGINE_METHOD_RAND;
-	else if (!strncmp(alg, "CIPHERS", len))
+	else if (!op_strncmp(alg, "CIPHERS", len))
 		*pflags |= ENGINE_METHOD_CIPHERS;
-	else if (!strncmp(alg, "DIGESTS", len))
+	else if (!op_strncmp(alg, "DIGESTS", len))
 		*pflags |= ENGINE_METHOD_DIGESTS;
 	else if (!strncmp(alg, "PKEY", len))
 		*pflags |=
@@ -179,3 +182,5 @@
 		ENGINE_register_complete(e);
 	return 1;
 	}
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/engine/eng_init.c openssl-1.0.0q/crypto/engine/eng_init.c
--- openssl-1.0.0q.orig/crypto/engine/eng_init.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/engine/eng_init.c	2017-04-25 16:23:40.247527546 +0200
@@ -53,6 +53,10 @@
  *
  */
 
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_ENGINE
+
 #include "eng_int.h"
 
 /* Initialise a engine type for use (or up its functional reference count
@@ -152,3 +156,5 @@
 		}
 	return to_return;
 	}
+
+#endif /* OPENSSL_NO_ENGINE */
